#!/usr/bin/python2

'''SgScan - sagator's mailbox/email scanner
 
version 0.3
 
(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
This program is licensed under GPL.
 
Usage:
  ./sgscan.py [file|mailbox]
'''

SAVECLEAN=''

import sys,os,re,cStringIO,time
from aglib import *

def scan(data,fn):
    mail.data=data
    mail.xheader=''
    debug(2, "Object: ",fn)
    scanarr,scannames=[],'None'
    for scnr in SCANNERS:
      debug(2,"Running: ",scnr.name)
      detected,virlist,scan_reply=do_scan(scnr,os.path.basename(fn))
      if scan_reply:
        debug(2, scan_reply)
      else:
        scanarr=scanarr+[scnr.name]
        scannames=string.join(scanarr,' ')
      if detected:
        print fn+":",detected
        return detected

def mailhdr(str):
    return str[0:5]=="From "

set_logfile('-')
set_debug_level(0)
# parse command line arguments
files=[]
n=1
while n<len(sys.argv):
  if sys.argv[n]=="--help":
    print "Usage: sgscan [--help] [--debug X] [--config name] [--clean] files..."
    sys.exit(0)
  elif sys.argv[n]=="--config":
    try:
      n=n+1
      SCANNERS=CONFIG[sys.argv[n]]
      set_scanners(SCANNERS)
    except KeyError:
      print "Config "+sys.argv[n]+" not found! Using default."
    except IndexError:
      print "--config requires an argument"
      sys.exit(1)
  elif sys.argv[n]=="--clean":
    SAVECLEAN=".clean"
  elif sys.argv[n]=="--debug":
    n=n+1
    set_debug_level(int(sys.argv[n]))
  else:
    files.append(sys.argv[n])
  n=n+1

for fn in files:
  total,infected=0,0
  time0=time.mktime(time.localtime())
  f=open(fn,"r")
  line1=f.readline()
  if mailhdr(line1):
    print fn+": mailbox detected"
    if SAVECLEAN:
      fc=open(fn+SAVECLEAN,"w")
    while 1:
      frm=line1
      lines=cStringIO.StringIO()
      while 1:
        line1=f.readline()
        if line1=="": break
        if mailhdr(line1): break
        lines.write(line1)
      if not scan(lines.getvalue(),frm.strip()):
        if SAVECLEAN:
          fc.write(line1)
          fc.write(lines.getvalue())
      else:
        infected+=1
      total+=1
      lines.close()
      if line1=="": break
  else:
    debug(2, "Scanning file: "+fn)
    scan(open(fn,'r').read(),fn)
  f.close()
  print "Total infected/spamed files/emails:",\
    str(infected)+"/"+str(total),"in:", \
    time.mktime(time.localtime())-time0,"seconds"
